--
-- Patch DDL de GRH_PECHE du 23/04/2013 à exécuter depuis le user GRH_PECHE
--
-- Rem : fichier encodé UTF-8

SET DEFINE OFF;

--
--
-- Fichier : 4/7
-- Type : DDL
-- Schema : GRH_PECHE
-- Numero de version : 0.2.0.0
-- Date de publication : 23/04/2013 
-- Auteur(s) : Cocktail
-- Licence : CeCILL version 2
--
--

WHENEVER SQLERROR EXIT SQL.SQLCODE;

--
-- CIRCUIT_VALIDATION
--
CREATE TABLE GRH_PECHE.CIRCUIT_VALIDATION
(
  ID_CIRCUIT_VALIDATION NUMBER	NOT NULL,
  ID_APP NUMBER(12,0) NOT NULL,
  C_CIRCUIT_VALIDATION	VARCHAR2(30) NOT NULL,
  NUMERO_VERSION NUMBER NOT NULL,
  LL_CIRCUIT_VALIDATION	VARCHAR2(100) NOT NULL,
  TEM_UTILISABLE VARCHAR2(1) DEFAULT 'N' NOT NULL,
  D_MODIFICATION DATE DEFAULT SYSDATE NOT NULL,
  PERS_ID_MODIFICATION NUMBER NOT NULL
);

ALTER TABLE GRH_PECHE.CIRCUIT_VALIDATION ADD CONSTRAINT PK_CIRCUIT_VALIDATION PRIMARY KEY(ID_CIRCUIT_VALIDATION) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.CIRCUIT_VALIDATION ADD CONSTRAINT UK_CIRCUIT_VALIDATION  UNIQUE (ID_APP, C_CIRCUIT_VALIDATION, NUMERO_VERSION);

ALTER TABLE GRH_PECHE.CIRCUIT_VALIDATION ADD CONSTRAINT FK_CIRCUIT_VALID_GD_APPLI FOREIGN KEY (ID_APP) REFERENCES GRHUM.GD_APPLICATION (APP_ID);

ALTER TABLE GRH_PECHE.CIRCUIT_VALIDATION ADD CONSTRAINT CHK_CIRCUIT_TEM_UTILISABLE CHECK (TEM_UTILISABLE IN ('O', 'N'));

CREATE SEQUENCE GRH_PECHE.CIRCUIT_VALIDATION_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.CIRCUIT_VALIDATION IS 'Table des circuits de validation';    
COMMENT ON COLUMN GRH_PECHE.CIRCUIT_VALIDATION.ID_CIRCUIT_VALIDATION IS 'Clef primaire de la table CIRCUIT_VALIDATION';
COMMENT ON COLUMN GRH_PECHE.CIRCUIT_VALIDATION.ID_APP IS 'Référence à l''application (cf. GRHUM.GD_APPLICATION.APP_ID)';
COMMENT ON COLUMN GRH_PECHE.CIRCUIT_VALIDATION.C_CIRCUIT_VALIDATION IS 'Code du circuit de validation';
COMMENT ON COLUMN GRH_PECHE.CIRCUIT_VALIDATION.NUMERO_VERSION IS 'Numéro de version du circuit';
COMMENT ON COLUMN GRH_PECHE.CIRCUIT_VALIDATION.LL_CIRCUIT_VALIDATION IS 'Libellé long du circuit de validation';
COMMENT ON COLUMN GRH_PECHE.CIRCUIT_VALIDATION.TEM_UTILISABLE IS 'Est-ce que le circuit de validation est utilisable ? (O/N)';
COMMENT ON COLUMN GRH_PECHE.CIRCUIT_VALIDATION.D_MODIFICATION IS 'Date de la derniere modification de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.CIRCUIT_VALIDATION.PERS_ID_MODIFICATION IS 'Pers_id de la personne à l''origine de la modification de l''enregistrement';

--
-- ETAPE
--
CREATE TABLE GRH_PECHE.ETAPE
(
  ID_ETAPE 	 	NUMBER	NOT NULL ,
  C_ETAPE		VARCHAR2(20) NOT NULL,
  LL_ETAPE		VARCHAR2(100) NOT NULL,
  ID_CIRCUIT_VALIDATION	NUMBER NOT NULL,
  TEM_ETAPE_INITIALE VARCHAR2(1) DEFAULT 'N' NOT NULL 
);

ALTER TABLE GRH_PECHE.ETAPE ADD CONSTRAINT PK_ETAPE PRIMARY KEY(ID_ETAPE) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.ETAPE  ADD CONSTRAINT UK_ETAPE_CODE_CIRCUIT  UNIQUE (C_ETAPE, ID_CIRCUIT_VALIDATION);

ALTER TABLE GRH_PECHE.ETAPE ADD CONSTRAINT FK_ETA_CIRCUIT_VALID FOREIGN KEY (ID_CIRCUIT_VALIDATION) REFERENCES GRH_PECHE.CIRCUIT_VALIDATION (ID_CIRCUIT_VALIDATION);
ALTER TABLE GRH_PECHE.ETAPE ADD CONSTRAINT CHK_ETA_TEM_ETAPE_INI CHECK (TEM_ETAPE_INITIALE IN ('O', 'N') );

CREATE INDEX GRH_PECHE.IDX_ETA_ID_CIRCUIT_VALID ON GRH_PECHE.ETAPE(ID_CIRCUIT_VALIDATION) TABLESPACE GRH_INDX;

CREATE SEQUENCE GRH_PECHE.ETAPE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.ETAPE IS 'Table des étapes générées(validation, annulation,...)';    
COMMENT ON COLUMN GRH_PECHE.ETAPE.ID_ETAPE IS 'Clef primaire de la table ETAPE';
COMMENT ON COLUMN GRH_PECHE.ETAPE.C_ETAPE IS 'Code de l''étape';
COMMENT ON COLUMN GRH_PECHE.ETAPE.LL_ETAPE IS 'Libellé long de l''étape';
COMMENT ON COLUMN GRH_PECHE.ETAPE.ID_CIRCUIT_VALIDATION IS 'Référence au circuit de validation (cf. GRH_PECHE.CIRCUIT_VALIDATION.ID_CIRCUIT_VALIDATION)';
COMMENT ON COLUMN GRH_PECHE.ETAPE.TEM_ETAPE_INITIALE IS 'Est-ce que c''est l''étape initiale ? (O:valide, N:invalide)';

--
-- DEMANDE
--
CREATE TABLE GRH_PECHE.DEMANDE
(
  ID_DEMANDE NUMBER NOT NULL ,
  ID_ETAPE NUMBER NOT NULL
);

ALTER TABLE GRH_PECHE.DEMANDE ADD CONSTRAINT PK_DEMANDE PRIMARY KEY(ID_DEMANDE) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.DEMANDE ADD CONSTRAINT FK_DEMANDE_ID_ETAPE FOREIGN KEY (ID_ETAPE) REFERENCES GRH_PECHE.ETAPE (ID_ETAPE);

CREATE INDEX GRH_PECHE.IDX_DEMANDE_ID_ETAPE ON GRH_PECHE.DEMANDE(ID_ETAPE) TABLESPACE GRH_INDX;

CREATE SEQUENCE GRH_PECHE.DEMANDE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.DEMANDE IS 'Table des demandes en cours';    
COMMENT ON COLUMN GRH_PECHE.DEMANDE.ID_DEMANDE IS 'Clef primaire de la table DEMANDE';
COMMENT ON COLUMN GRH_PECHE.DEMANDE.ID_ETAPE IS 'Référence à l''étape en cours (cf. GRH_PECHE.ETAPE.ID_ETAPE)';

--
-- CHEMIN
--
CREATE TABLE GRH_PECHE.CHEMIN
(
  ID_CHEMIN NUMBER NOT NULL,
  ID_ETAPE_DEPART NUMBER NOT NULL,
  ID_ETAPE_ARRIVEE NUMBER,
  C_TYPE_CHEMIN VARCHAR2(20) NOT NULL,
  LC_TYPE_CHEMIN VARCHAR2(50) NOT NULL
);

ALTER TABLE GRH_PECHE.CHEMIN ADD CONSTRAINT PK_CHEMIN PRIMARY KEY(ID_CHEMIN) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.CHEMIN ADD CONSTRAINT FK_CHEMIN_ETAPE_DEPART FOREIGN KEY (ID_ETAPE_DEPART) REFERENCES GRH_PECHE.ETAPE (ID_ETAPE);
ALTER TABLE GRH_PECHE.CHEMIN ADD CONSTRAINT FK_CHEMIN_ETAPE_ARRIVEE FOREIGN KEY (ID_ETAPE_ARRIVEE) REFERENCES GRH_PECHE.ETAPE (ID_ETAPE);
ALTER TABLE GRH_PECHE.CHEMIN ADD CONSTRAINT UK_CHEMIN_ETAPE_DEPART_TYP_CHE UNIQUE (ID_ETAPE_DEPART, C_TYPE_CHEMIN);

CREATE INDEX GRH_PECHE.IDX_CHEMIN_ETAPE_DEPART ON GRH_PECHE.CHEMIN(ID_ETAPE_DEPART) TABLESPACE GRH_INDX;
CREATE INDEX GRH_PECHE.IDX_CHEMIN_ETAPE_ARRIVEE ON GRH_PECHE.CHEMIN(ID_ETAPE_ARRIVEE) TABLESPACE GRH_INDX;

CREATE SEQUENCE GRH_PECHE.CHEMIN_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.CHEMIN IS 'Table des chemins valides';   
COMMENT ON COLUMN GRH_PECHE.CHEMIN.ID_CHEMIN IS 'Clef primaire de la table CHEMIN'; 
COMMENT ON COLUMN GRH_PECHE.CHEMIN.ID_ETAPE_DEPART IS 'Référence à l''étape de départ (cf. GRH_PECHE.ETAPE.ID_ETAPE), peut être à null si étape initiale';
COMMENT ON COLUMN GRH_PECHE.CHEMIN.ID_ETAPE_ARRIVEE IS 'Référence à l''étape d''arrivée (cf. GRH_PECHE.ETAPE.ID_ETAPE)';
COMMENT ON COLUMN GRH_PECHE.CHEMIN.C_TYPE_CHEMIN IS 'Code du type de chemin';
COMMENT ON COLUMN GRH_PECHE.CHEMIN.LC_TYPE_CHEMIN IS 'Libellé court du type de chemin';

--
-- HISTORIQUE_DEMANDE
--
CREATE TABLE GRH_PECHE.HISTORIQUE_DEMANDE
(
  ID_HISTORIQUE_DEMANDE NUMBER NOT NULL ,
  ID_DEMANDE 		NUMBER NOT NULL ,
  ID_ETAPE_DEPART  	NUMBER,
  ID_ETAPE_ARRIVEE   	NUMBER NOT NULL,
  PERS_ID_MODIFICATION 	NUMBER NOT NULL,
  D_MODIFICATION 	DATE DEFAULT SYSDATE NOT NULL
  
);

ALTER TABLE GRH_PECHE.HISTORIQUE_DEMANDE ADD CONSTRAINT PK_HISTORIQUE_DEMANDE PRIMARY KEY(ID_HISTORIQUE_DEMANDE) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.HISTORIQUE_DEMANDE ADD CONSTRAINT FK_HD_ID_DEMANDE FOREIGN KEY (ID_DEMANDE) REFERENCES GRH_PECHE.DEMANDE (ID_DEMANDE);
ALTER TABLE GRH_PECHE.HISTORIQUE_DEMANDE ADD CONSTRAINT FK_HD_ID_ETAPE_DEPART FOREIGN KEY (ID_ETAPE_DEPART) REFERENCES GRH_PECHE.ETAPE (ID_ETAPE);
ALTER TABLE GRH_PECHE.HISTORIQUE_DEMANDE ADD CONSTRAINT FK_HD_ID_ETAPE_ARRIVEE FOREIGN KEY (ID_ETAPE_ARRIVEE) REFERENCES GRH_PECHE.ETAPE (ID_ETAPE);
ALTER TABLE GRH_PECHE.HISTORIQUE_DEMANDE ADD CONSTRAINT FK_HD_PERS_ID_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);

CREATE INDEX GRH_PECHE.IDX_HD_ID_DEMANDE ON GRH_PECHE.HISTORIQUE_DEMANDE(ID_DEMANDE) TABLESPACE GRH_INDX;
CREATE INDEX GRH_PECHE.IDX_HD_ETAPE_DEPART ON GRH_PECHE.HISTORIQUE_DEMANDE(ID_ETAPE_DEPART) TABLESPACE GRH_INDX;
CREATE INDEX GRH_PECHE.IDX_HD_ETAPE_ARRIVEE ON GRH_PECHE.HISTORIQUE_DEMANDE(ID_ETAPE_ARRIVEE) TABLESPACE GRH_INDX;
CREATE INDEX GRH_PECHE.IDX_HD_PERS_MODIFICATION ON GRH_PECHE.HISTORIQUE_DEMANDE(PERS_ID_MODIFICATION) TABLESPACE GRH_INDX;

CREATE SEQUENCE GRH_PECHE.HISTORIQUE_DEMANDE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.HISTORIQUE_DEMANDE IS 'Historisation des demandes qui change d''étape'; 
COMMENT ON COLUMN GRH_PECHE.HISTORIQUE_DEMANDE.ID_HISTORIQUE_DEMANDE IS 'Clef primaire de la table HISTORIQUE_DEMANDE';   
COMMENT ON COLUMN GRH_PECHE.HISTORIQUE_DEMANDE.ID_DEMANDE IS 'Référence à la demande historisée (cf. GRH_PECHE.DEMANDE.ID_DEMANDE)';
COMMENT ON COLUMN GRH_PECHE.HISTORIQUE_DEMANDE.ID_ETAPE_DEPART IS 'Référence à l''étape de départ (cf. GRH_PECHE.ETAPE.ID_ETAPE), peut être à null si étape initiale';
COMMENT ON COLUMN GRH_PECHE.HISTORIQUE_DEMANDE.ID_ETAPE_ARRIVEE IS 'Référence à l''étape d''arrivée (cf. GRH_PECHE.ETAPE.ID_ETAPE)';
COMMENT ON COLUMN GRH_PECHE.HISTORIQUE_DEMANDE.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification du statut de la demande';
COMMENT ON COLUMN GRH_PECHE.HISTORIQUE_DEMANDE.D_MODIFICATION IS 'Date de modification de la demande';

--
-- PECHE_PARAMETRES
--
CREATE TABLE GRH_PECHE.PECHE_PARAMETRES
(
  PARAM_ID              NUMBER NOT NULL ,
  PARAM_KEY             VARCHAR2(2000),
  PARAM_VALUE           VARCHAR2(500) ,
  PARAM_COMMENTAIRES    VARCHAR2(500) ,
  D_CREATION            DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION        DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION      NUMBER NOT NULL ,
  PERS_ID_MODIFICATION  NUMBER 
);

ALTER TABLE GRH_PECHE.PECHE_PARAMETRES ADD CONSTRAINT PK_PECHE_PARAMETRES PRIMARY KEY(PARAM_ID) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.PECHE_PARAMETRES ADD CONSTRAINT FK_PARAM_PERS_ID_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE GRH_PECHE.PECHE_PARAMETRES ADD CONSTRAINT FK_PARAM_PERS_ID_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
  
CREATE INDEX GRH_PECHE.IDX_PARAM_PARAM_KEY ON GRH_PECHE.PECHE_PARAMETRES(PARAM_KEY) TABLESPACE GRH_INDX;

CREATE SEQUENCE GRH_PECHE.PECHE_PARAMETRES_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE  GRH_PECHE.PECHE_PARAMETRES IS 'Les paramètres de l''application PECHE';
COMMENT ON COLUMN GRH_PECHE.PECHE_PARAMETRES.PARAM_ID IS 'Clef primaire de la table PECHE_PARAMETRES.';
COMMENT ON COLUMN GRH_PECHE.PECHE_PARAMETRES.PARAM_KEY IS 'Code du paramètre ';
COMMENT ON COLUMN GRH_PECHE.PECHE_PARAMETRES.PARAM_VALUE IS 'Valeur du paramètre';
COMMENT ON COLUMN GRH_PECHE.PECHE_PARAMETRES.PARAM_COMMENTAIRES IS 'Commentaire du paramètre';
COMMENT ON COLUMN GRH_PECHE.PECHE_PARAMETRES.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.PECHE_PARAMETRES.D_MODIFICATION IS 'Date de la dernière modification de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.PECHE_PARAMETRES.PERS_ID_CREATION IS 'Pers_id de la personne à l''origine de la création de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.PECHE_PARAMETRES.PERS_ID_MODIFICATION IS 'Pers_id de la personne à l''origine de la modification de l''enregistrement.';

--
-- METHODES_CALCUL_HCOMP
--
CREATE TABLE GRH_PECHE.METHODES_CALCUL_HCOMP
(
  METHODE_ID            NUMBER NOT NULL ,
  LL_METHODE            VARCHAR2(100),
  CLASSE_METHODE        VARCHAR2(100) ,
  D_CREATION            DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION        DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION      NUMBER NOT NULL ,
  PERS_ID_MODIFICATION  NUMBER 
);

ALTER TABLE GRH_PECHE.METHODES_CALCUL_HCOMP ADD CONSTRAINT PK_METHODES_CALCUL_HCOMP PRIMARY KEY(METHODE_ID) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.METHODES_CALCUL_HCOMP ADD CONSTRAINT FK_METHODES_PERS_ID_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE GRH_PECHE.METHODES_CALCUL_HCOMP ADD CONSTRAINT FK_METH_PERS_ID_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
  
CREATE SEQUENCE GRH_PECHE.METHODES_CALCUL_HCOMP_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE  GRH_PECHE.METHODES_CALCUL_HCOMP IS 'Les méthodes de calculs des heures complémentaires';
COMMENT ON COLUMN GRH_PECHE.METHODES_CALCUL_HCOMP.METHODE_ID IS 'Clef primaire de la table METHODES_CALCUL_HCOMP.';
COMMENT ON COLUMN GRH_PECHE.METHODES_CALCUL_HCOMP.LL_METHODE IS 'Le libellé de la méthode de calcul';
COMMENT ON COLUMN GRH_PECHE.METHODES_CALCUL_HCOMP.CLASSE_METHODE IS 'Le nom de la classe Java qui permet de faire le calcul';
COMMENT ON COLUMN GRH_PECHE.METHODES_CALCUL_HCOMP.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.METHODES_CALCUL_HCOMP.D_MODIFICATION IS 'Date de la dernière modification de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.METHODES_CALCUL_HCOMP.PERS_ID_CREATION IS 'Pers_id de la personne à l''origine de la création de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.METHODES_CALCUL_HCOMP.PERS_ID_MODIFICATION IS 'Pers_id de la personne à l''origine de la modification de l''enregistrement.';

--
-- REPART_METHODE_CORPS
--
CREATE TABLE GRH_PECHE.REPART_METHODE_CORPS
(
  METHODE_ID     NUMBER NOT NULL,
  C_CORPS        VARCHAR2(4) NOT NULL,
  D_CREATION     DATE DEFAULT SYSDATE NOT NULL,
  D_MODIFICATION DATE DEFAULT SYSDATE NOT NULL
);

ALTER TABLE GRH_PECHE.REPART_METHODE_CORPS ADD CONSTRAINT PK_REPART_METHODE_CORPS PRIMARY KEY(METHODE_ID, C_CORPS);
ALTER TABLE GRH_PECHE.REPART_METHODE_CORPS ADD CONSTRAINT FK_REPART_METHODE_CORPS_METHO FOREIGN KEY (METHODE_ID) REFERENCES GRH_PECHE.METHODES_CALCUL_HCOMP(METHODE_ID);
ALTER TABLE GRH_PECHE.REPART_METHODE_CORPS ADD CONSTRAINT FK_REPART_METHODE_CORPS_CORPS FOREIGN KEY (C_CORPS) REFERENCES GRHUM.CORPS(C_CORPS);

COMMENT ON TABLE GRH_PECHE.REPART_METHODE_CORPS IS 'Répartition des méthodes de calculs pour les corps des enseignants.';
COMMENT ON COLUMN GRH_PECHE.REPART_METHODE_CORPS.METHODE_ID IS 'Référence la clef primaire de la table GRH_PECHE.METHODES_CALCUL_HCOMP.';
COMMENT ON COLUMN GRH_PECHE.REPART_METHODE_CORPS.METHODE_ID IS 'Référence la clef primaire de la table GRHUM.CORPS.';
COMMENT ON COLUMN GRH_PECHE.REPART_METHODE_CORPS.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.REPART_METHODE_CORPS.D_MODIFICATION IS 'Date de la dernière modification de l''enregistrement.';

